module SPImaging
  class Configuration
    class <<self
      attr_accessor :configuration_file

      def current
        env = nil
        env = Rails.env if defined? Rails
        env ||= ENV['RAILS_ENV']
        env ||= ENV['RACK_ENV']
        raise 'Unable to determine environment' if env.nil?

        c = read
        raise "Environment not defined in SPImaging configuration: #{env}" if c[env].nil?
        (c['global'] || {}).merge(c[env])
      end

      private

      def read
        if defined? Rails
          self.configuration_file ||= File.join(Rails.root, 'config', 'spimaging.yml')
        elsif self.configuration_file.nil?
          raise 'Unable to determine a default location for SPImaging configuration'
        end

        @configuration ||= YAML.load_file(self.configuration_file)
      end
    end
  end
end
