require 'nokogiri'

module SPImaging
  class ShowImagesRequest
    attr_accessor :uuids, :xml

    def initialize(uuids)
      self.uuids = uuids
    end

    def download

      builder = Nokogiri::XML::Builder.new :encoding => 'utf-8' do |xml|
        # Clients that treat this as a real builder sometimes need to call 'tag!'
        # That's ok.
        def xml.tag!(*args, &bl)
          # Handle reserved names correctly
          name = args.shift + '_'
          send name, *args, &bl
        end

        xml.spimaging do
          xml.uuids do
            uuids.each do | uuid |
              xml.uuid(uuid)
            end
          end
        end
      end

      @xml = builder.to_xml
      SPImaging::Protocol.instance.download_images @xml
    end
  end
end
